// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MAPDEF_H
#define MAPDEF_H

#include <stdlib.h>
#include "maptile.h"
#include "xmlhelper.h"
#include "MapGenerator.h"

class TempleList;

class Mapdef
{
	public:
		Mapdef();
		Mapdef(XML_Helper* helper);
		~Mapdef();
		
		// Set methods
		void setPlayers(int players){d_players = players;}
		void setName(std::string name){d_name = name;}
		void setInfo(std::string info){d_info = info;}

		// Get methods
		int getPlayers(){return d_players;}
		std::string getName(){return d_name;}
		std::string getInfo(){return d_info;}
        TileSet* getTileSet(){return d_tileSet;}

		// Methods
        bool fill(MapGenerator* generator);
		void random();
		bool save(XML_Helper* helper);
	
		// Data
		Maptile* map[100][100];

	private:
		// Methods
		bool isUsed(int x, int y);

		// Data
        TileSet* d_tileSet;
        TempleList* d_templeList;
		std::string d_name;
		std::string d_info;
		int d_players;
};

extern Mapdef* mapdef;

#endif // MAPDEF_H

// End of file
